
-- lua made by Pacola for the mario mod yay :D

freeslot("S_MAR_SWIM", "S_MAR_SWIMIDLE", "sfx_smbswm")

states[S_MAR_SWIM] = {
    sprite = SPR_PLAY,
    frame = SPR2_SPNG|FF_SPR2ENDSTATE,
    tics = 5,
	var1 = S_MAR_SWIMIDLE,
    nextstate = S_MAR_SWIM
}

states[S_MAR_SWIMIDLE] = {
    sprite = SPR_PLAY,
    frame = SPR2_FALL,
    tics = 5,
    nextstate = S_MAR_SWIMIDLE
}

sfxinfo[sfx_smbswm].caption = "Swim"

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "ebina" return end
	
	if player.marjumpheld == nil
		player.marjumpheld = 0
	end
	
	if (player.cmd.buttons & BT_JUMP)
		player.marjumpheld = $+1
	else
		player.marjumpheld = 0
	end
	
	player.powers[pw_underwater] = 0
	
	if (player.mo.eflags & MFE_UNDERWATER)
	and player.playerstate ~= PST_DEAD
	and not player.groundpound
		S_StopSoundByID(player.mo, sfx_mario6)
		player.pflags = $ & ~PF_JUMPED
		if player.mo.state ~= S_MAR_SWIM
		and not P_IsObjectOnGround(player.mo)
		and not P_PlayerInPain(player)
		and player.mo.state ~= S_MAR_SWIMIDLE
			player.mo.state = S_MAR_SWIMIDLE
		end
		if player.marjumpheld == 1
		and not P_PlayerInPain(player)
			player.pflags = $ & ~PF_SPINNING
			P_SetObjectMomZ(player.mo, 5*FU)
			player.mo.state = S_MAR_SWIM
			S_StartSound(player.mo, sfx_smbswm)
		end
	elseif player.mo.state == S_MAR_SWIM
	or player.mo.state == S_MAR_SWIMIDLE
		player.mo.state = S_PLAY_JUMP
		if (player.cmd.buttons & BT_JUMP)
			P_DoJump(player, true)
		end
	end
end)