freeslot("S_MAR_CROUCH", "SPR2_CRCH", "S_MAR_CROUCHWALK")

states[S_MAR_CROUCH] = {
    sprite = SPR_PLAY,
    frame = SPR2_CRCH,
    tics = -1,
    nextstate = S_MAR_CROUCH
}

states[S_MAR_CROUCHWALK] = {
    sprite = SPR_PLAY,
    frame = A|SPR2_CRCH|FF_ANIMATE,
    tics = 10,
    nextstate = S_MAR_CROUCH,
	var1 = 50,
	var2 = 25
}


-- thanks pacola for making the super jump parts of the code
addHook("PlayerThink", function(player)
    if player.mo.skin == "ebina"
        if player.sjtimer == nil
        or not player.crouch
            player.sjtimer = 1*TICRATE -- change every 3*TICRATE mention to whatever time you want
        end
        
		if not player.crouch
		and player.oldcolor
			player.oldcolor = nil
		end
		
        if (player.cmd.buttons & BT_CUSTOM3)
        and P_IsObjectOnGround(player.mo)
        and not player.mo.standingslope
		and not player.markick
		and not player.slide
		and not player.groundgaltwirl
		and not player.groundpound
        and not P_PlayerInPain(player)
            player.crouch = true
            player.normalspeed = 5*FRACUNIT
            player.height = P_GetPlayerSpinHeight(player)
            if player.speed > 0
                player.mo.state = S_MAR_CROUCHWALK
            else
                player.mo.state = S_MAR_CROUCH
            end
			if not (player.mo.eflags & MFE_UNDERWATER)
				if player.sjtimer
					player.sjtimer = $-1
				else
					if player.mo.color ~= SKINCOLOR_WHITE
						player.oldcolor = player.mo.color
					end
					if leveltime%10 <= 5
						player.mo.color = SKINCOLOR_WHITE
					elseif player.oldcolor
						player.mo.color = player.oldcolor
					end
					player.jumpfactor = FixedMul(skins[player.mo.skin].jumpfactor, FixedDiv(3*FU, 2*FU))
				end
			end
        elseif player.crouch
            player.crouch = false
            player.height = skins[player.mo.skin].height
            player.normalspeed = skins[player.mo.skin].normalspeed
            player.jumpfactor = skins[player.mo.skin].jumpfactor
            if player.oldcolor
                player.mo.color = player.oldcolor
            end
            if not P_PlayerInPain(player)
				if (player.pflags & PF_JUMPED)
					player.mo.state = S_PLAY_JUMP
				else
					player.mo.state = S_PLAY_STND
				end
            end
        end
    end
end)